#!/usr/bin/perl
## makenewjis.pl (Ver. 1.0.0)
## (C) 2003 Takeshi WATANABE <t-wata@dab.hi-ho.ne.jp>
########################################################################
##
## ʪδĴ (ñ)
##
$kanjiskip_plus = 0.05;
$kanjiskip_minus = 0.02;
##
## ѷΨ (-j : ̾-g : ̾)
##
$scale = 1.0;
if ($ARGV[0] =~ /^\-([jg])(\d+)$/) {
    $ji = ($1 eq "j") ? 1 : 0;
    $scale = $2 / 1000.;
}
$yokofile = sprintf("ynewjis%s.pl", ($scale == 1.0 ? "" : $ARGV[0]));
$tatefile = sprintf("tnewjis%s.pl", ($scale == 1.0 ? "" : $ARGV[0]));
##
## ʸ饹
##
$kanji = $class = 0;
$char{$S_kakko  = ++$class} = '';
$char{$E_kakko  = ++$class} = '';
$char{$S_kagi   = ++$class} = '         ';
$char{$E_kagi   = ++$class} = '         ';
$char{$cdot     = ++$class} = '  ';
$char{$comma    = ++$class} = ' ';
$char{$period   = ++$class} = ' ';
$char{$question = ++$class} = ' ';
$char{$dash     = ++$class} = '  ';
$char{$zspc     = ++$class} = ''; # ѥڡ
##
## ʸȤ߶
##   (§ŬϽפʤΤǡѰդ elsif νѤʤ褦)
##
sub glue
{
    local($pre, $post) = @_;
    local($skip, $plus, $minus) = (0., $kanjiskip_plus, $kanjiskip_minus);

# 
    if ($pre == $cdot || $post == $cdot) {
	if ($pre == $cdot && $post == $cdot) { # JIS X 4051 ɽ2 (̣ʤ)
	    $skip = .5;
	    $minus = .5;
	} elsif ($pre == $period) { # JIS X 4051 ɽ2 (̣ʤ)
	    $skip = .75;
	    $minus = .25;
	} else {
	    $skip = .25;
	    $plus /= 2.; # ˶ΤǡĴ̤ȾʬĤ
	    $minus = .25;
	}
    }
# ̤¦ (жʤ)
    elsif ($pre == $S_kakko || $pre == $S_kagi
	   || $post == $E_kakko || $post == $E_kagi
	   || $post == $comma || $post == $period) {
	$plus = 0.;
    }
# θ
    elsif ($pre == $period) {
	$skip = .5;
	$minus = 0.; # ͤʤ
    }
# ѥڡ (TeX ǤϤޤȤʤȻפɡ)
    elsif ($pre == $zspc || $post == $zspc) {
	; # ε§˰äʤ褦
    }
# θ
    elsif ($pre == $comma) {
	$skip = .5;
	$minus = .25; # ʬޤ
    }
# γ¦
    elsif ($pre == $E_kagi || $post == $S_kagi) {
	$skip = .5;
	$minus = .3125; # ȬʬޤǡĤʤ⤦ä¿ζ
    }
# ݳ̤γ¦
    elsif ($pre == $E_kakko || $post == $S_kakko) {
	$skip = .5;
	$minus = .5; # ٥ޤ
    }
# ޡ
    elsif ($post == $question) {
	$plus = 0.;
    }
# å
    elsif ($pre == $dash || $post == $dash) {
	if ($pre == $dash && $post == $dash) {
	    return (); # ʬΥػ
	} else {
	    $minus /= 2.; # åʸȰդΤǵͤޤˤ
	}
    }
    return ($skip, $plus, $minus);
}
##
## PLե˽񤭽Ф
##
open(YOKO, "> $yokofile") || die "cannot open file \'$yokofile\'.\n";
open(TATE, "> $tatefile") || die "cannot open file \'$tatefile\'.\n";
print YOKO "(DIRECTION YOKO)\n";
print TATE "(DIRECTION TATE)\n";
&output("(FAMILY KANJI)\n");
&output("(FACE F MRR)\n");
&output("(CODINGSCHEME TEX KANJI TEXT)\n");
&output("(DESIGNSIZE R 10.0)\n");
&output("(FONTDIMEN\n");
&output("  (SLANT R 0.0)\n");
&output("  (SPACE R 0.0)\n");
&output("  (STRETCH R %f)\n", $kanjiskip_plus);
&output("  (SHRINK R %f)\n", $kanjiskip_minus);
&output("  (XHEIGHT R %f)\n", ($ji ? 1.0 : $scale));
&output("  (QUAD R %f)\n", ($ji ? $scale : 1.0));
&output("  (EXTRASPACE R 0.25)\n");
&output("  (EXTRASTRETCH R 0.125)\n");
&output("  (EXTRASHRINK R 0.0675)\n");
&output("  )\n");
##
for ($i = 1; $i <= $class; $i++) {
    &output("(CHARSINTYPE D %d\n  %s\n  )\n", $i, $char{$i});
}
##
for ($i = 0; $i <= $class; $i++) {
    &output("(TYPE D %d\n", $i);
    if ($i == $kanji || $i == $question || $i == $dash || $i == $zspc) {
	&output("  (CHARWD R %f)\n", ($ji ? $scale : 1.0));
    } else {
	&output("  (CHARWD R %f)\n", ($ji ? $scale : 1.0) * 0.5);
    }
    printf YOKO "  (CHARHT R %f)\n", ($ji ? 1.0 : $scale) * 0.876;
    printf TATE "  (CHARHT R %f)\n", ($ji ? 1.0 : $scale) * 0.5;
    printf YOKO "  (CHARDP R %f)\n", ($ji ? 1.0 : $scale) * 0.124;
    printf TATE "  (CHARDP R %f)\n", ($ji ? 1.0 : $scale) * 0.5;
    &output("  )\n");
}
##
&output("(GLUEKERN\n");
for ($i = 0; $i <= $class; $i++) {
    &output("  (LABEL D %d)\n", $i);
    for ($j = 0; $j <= $class; $j++) {
	next if $i == $kanji && $j == $kanji; # \kanjiskip Ǥ
	local(@_) = &glue($i, $j);
	if ($#_ < 0) {
	    &output("  (KRN  D %2d R 0.0)\n", $j);
	} else {
	    if ($ji) {
		@_ = ($_[0] * $scale, $_[1] * $scale, $_[2] * $scale);
	    }
	    &output("  (GLUE D %2d R %8.6f R %8.6f R %8.6f)\n", $j, @_);
	}
    }
    &output("  (STOP)\n");
}
&output("  )\n");
close YOKO;
close TATE;
exit;
##
sub output
{
    printf YOKO @_;
    printf TATE @_;
}
##EOF
